/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the AuditOperationDetails type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AuditOperationDetails{}

// AuditOperationDetails struct for AuditOperationDetails
type AuditOperationDetails struct {
	Application *Application `json:"application,omitempty"`
	Account     *Account     `json:"account,omitempty"`
	Identity    *Identity    `json:"identity,omitempty"`
	Target1     interface{}  `json:"target1,omitempty"`
	Target2     interface{}  `json:"target2,omitempty"`
}

// NewAuditOperationDetails instantiates a new AuditOperationDetails object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAuditOperationDetails() *AuditOperationDetails {
	this := AuditOperationDetails{}
	return &this
}

// NewAuditOperationDetailsWithDefaults instantiates a new AuditOperationDetails object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAuditOperationDetailsWithDefaults() *AuditOperationDetails {
	this := AuditOperationDetails{}
	return &this
}

// GetApplication returns the Application field value if set, zero value otherwise.
func (o *AuditOperationDetails) GetApplication() Application {
	if o == nil || IsNil(o.Application) {
		var ret Application
		return ret
	}
	return *o.Application
}

// GetApplicationOk returns a tuple with the Application field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuditOperationDetails) GetApplicationOk() (*Application, bool) {
	if o == nil || IsNil(o.Application) {
		return nil, false
	}
	return o.Application, true
}

// HasApplication returns a boolean if a field has been set.
func (o *AuditOperationDetails) HasApplication() bool {
	if o != nil && !IsNil(o.Application) {
		return true
	}

	return false
}

// SetApplication gets a reference to the given Application and assigns it to the Application field.
func (o *AuditOperationDetails) SetApplication(v Application) {
	o.Application = &v
}

// GetAccount returns the Account field value if set, zero value otherwise.
func (o *AuditOperationDetails) GetAccount() Account {
	if o == nil || IsNil(o.Account) {
		var ret Account
		return ret
	}
	return *o.Account
}

// GetAccountOk returns a tuple with the Account field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuditOperationDetails) GetAccountOk() (*Account, bool) {
	if o == nil || IsNil(o.Account) {
		return nil, false
	}
	return o.Account, true
}

// HasAccount returns a boolean if a field has been set.
func (o *AuditOperationDetails) HasAccount() bool {
	if o != nil && !IsNil(o.Account) {
		return true
	}

	return false
}

// SetAccount gets a reference to the given Account and assigns it to the Account field.
func (o *AuditOperationDetails) SetAccount(v Account) {
	o.Account = &v
}

// GetIdentity returns the Identity field value if set, zero value otherwise.
func (o *AuditOperationDetails) GetIdentity() Identity {
	if o == nil || IsNil(o.Identity) {
		var ret Identity
		return ret
	}
	return *o.Identity
}

// GetIdentityOk returns a tuple with the Identity field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuditOperationDetails) GetIdentityOk() (*Identity, bool) {
	if o == nil || IsNil(o.Identity) {
		return nil, false
	}
	return o.Identity, true
}

// HasIdentity returns a boolean if a field has been set.
func (o *AuditOperationDetails) HasIdentity() bool {
	if o != nil && !IsNil(o.Identity) {
		return true
	}

	return false
}

// SetIdentity gets a reference to the given Identity and assigns it to the Identity field.
func (o *AuditOperationDetails) SetIdentity(v Identity) {
	o.Identity = &v
}

// GetTarget1 returns the Target1 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuditOperationDetails) GetTarget1() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Target1
}

// GetTarget1Ok returns a tuple with the Target1 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuditOperationDetails) GetTarget1Ok() (*interface{}, bool) {
	if o == nil || IsNil(o.Target1) {
		return nil, false
	}
	return &o.Target1, true
}

// HasTarget1 returns a boolean if a field has been set.
func (o *AuditOperationDetails) HasTarget1() bool {
	if o != nil && !IsNil(o.Target1) {
		return true
	}

	return false
}

// SetTarget1 gets a reference to the given interface{} and assigns it to the Target1 field.
func (o *AuditOperationDetails) SetTarget1(v interface{}) {
	o.Target1 = v
}

// GetTarget2 returns the Target2 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuditOperationDetails) GetTarget2() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Target2
}

// GetTarget2Ok returns a tuple with the Target2 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuditOperationDetails) GetTarget2Ok() (*interface{}, bool) {
	if o == nil || IsNil(o.Target2) {
		return nil, false
	}
	return &o.Target2, true
}

// HasTarget2 returns a boolean if a field has been set.
func (o *AuditOperationDetails) HasTarget2() bool {
	if o != nil && !IsNil(o.Target2) {
		return true
	}

	return false
}

// SetTarget2 gets a reference to the given interface{} and assigns it to the Target2 field.
func (o *AuditOperationDetails) SetTarget2(v interface{}) {
	o.Target2 = v
}

func (o AuditOperationDetails) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AuditOperationDetails) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Application) {
		toSerialize["application"] = o.Application
	}
	if !IsNil(o.Account) {
		toSerialize["account"] = o.Account
	}
	if !IsNil(o.Identity) {
		toSerialize["identity"] = o.Identity
	}
	if o.Target1 != nil {
		toSerialize["target1"] = o.Target1
	}
	if o.Target2 != nil {
		toSerialize["target2"] = o.Target2
	}
	return toSerialize, nil
}

type NullableAuditOperationDetails struct {
	value *AuditOperationDetails
	isSet bool
}

func (v NullableAuditOperationDetails) Get() *AuditOperationDetails {
	return v.value
}

func (v *NullableAuditOperationDetails) Set(val *AuditOperationDetails) {
	v.value = val
	v.isSet = true
}

func (v NullableAuditOperationDetails) IsSet() bool {
	return v.isSet
}

func (v *NullableAuditOperationDetails) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAuditOperationDetails(val *AuditOperationDetails) *NullableAuditOperationDetails {
	return &NullableAuditOperationDetails{value: val, isSet: true}
}

func (v NullableAuditOperationDetails) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAuditOperationDetails) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
